<?php
/**
 * Perforce Swarm
 *
 * @copyright   2013 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level folder of this distribution.
 * @version     <release>/<patch>
 */

namespace Slack;

use P4\Spec\Change;
use Zend\View\Helper\AbstractHelper;

/**
 * Provides persistent storage and indexing of comments.
 */
class Message extends AbstractHelper
{
	protected $msg = '';

	public function __construct($host, Change $change)
    {
        $this->msg = $this->formatChange($host, $change);
    }
    
    public function toString()
    {
    	return $this->msg;
    }
    
    private function formatChange($host, $change)
    {
    	$id           = $change->getId();
    	$id_url       = $host('change', array('change' => $id));  
    	$description  = $change->getDescription();
    	$user         = $change->getUser();
    	$user_url     = $host('user', array('user' => $user)); 
    	$client       = $change->getClient();
    	$date         = $change->getDate();
    	
    	$summary = "Change " . "<" . $id_url . "|" . $id . ">" 
    		. " by " . "<" . $user_url . "|" . $user . "@" . $client . ">"
    		. " on " . $date . "\n";
    		
    	$files = $change->getFiles();
    		
		$msg = $summary . $description . "\n";
		return $msg;
	}
}